#include <stdio.h>
#include <conio.h>

unsigned char picbuf[4158];
unsigned char charsetbuf[4096];


int main(int argc, char* argv[])
{
  FILE *fin, *fout;
  int j,o,no,ino;
  printf("\nBitmap to Charset converter V1.0\n\n");
  if (argc != 3)
  {
    printf("Parameters:   bmp2char  bitmapfile  charsetfile\n\n");
    return 0;
  }

  /* load charset file */
  fin = fopen(argv[1],"rb");
  if (!fin)
  {
    printf("failed to open bitmap file!\n\n");
    return 1;
  }
  if (fread(picbuf,1,4158,fin)!=4158)
  {
    printf("failed to read bitmap file!\n\n");
    fclose(fin);
    return 1;
  }
  fclose(fin);
  if ((picbuf[0]!=0x42)||(picbuf[1]!=0x4d)||(picbuf[2]!=0x3e)||
      (picbuf[17]!=0)||(picbuf[18]!=0x80)||
      (picbuf[22]!=0)||(picbuf[23]!=0x01))
  {
    printf("error: bitmap must be single color with 128x256 pixels!\n\n");
    return 1;
  }

  /* copy all characters */
  for(no=0;no<256;no++)
  {
    ino = 255-no;
    o = 62 + (ino/16)*256+(no%16);
    for (j=0;j<16;j++)
    {
      charsetbuf[(no<<4)+j] = picbuf[o+(15-j)*16]^0xFF;
    }
  }

  /* write charset file */
  fout = fopen(argv[2],"wb");
  if (!fout)
  {
    printf("failed to open destination (charset) file!\n\n");
    return 1;
  }
  if (fwrite(charsetbuf,1,4096,fout)!=4096)
  {
    printf("failed to write charset file!\n\n");
    fclose(fout);
    return 1;
  }
  fclose(fout);
  printf("Charset file successfully created!\n\n");
  return 0;
}
