#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

unsigned char picbuf[32062];
unsigned char *charsetbuf;


int main(int argc, char* argv[])
{
  FILE *fin, *fout;
  int x,y;
  printf("\nBitmap to MyCPU-Graphic converter V1.0\n\n");
  if (argc != 3)
  {
    printf("Parameters:   bmp2gfx  bitmapfile  graphixfile\n\n");
    return 0;
  }
  charsetbuf=(unsigned char*)malloc(0x8000);
  if(!charsetbuf)
  {
    printf("out of memory error!\n");
    return 1;
  }

  /* load bitmap file */
  fin = fopen(argv[1],"rb");
  if (!fin)
  {
    printf("failed to open bitmap file!\n\n");
    return 1;
  }
  if (fread(picbuf,1,32062,fin)!=32062)
  {
    printf("failed to read bitmap file!\n\n");
    fclose(fin);
    return 1;
  }
  fclose(fin);
  if ((picbuf[0]!=0x42)||(picbuf[1]!=0x4d)||(picbuf[2]!=0x3e)||
      (picbuf[18]!=0x80)||(picbuf[19]!=0x02)||
      (picbuf[22]!=0x90)||(picbuf[23]!=0x01))
  {
    printf("error: bitmap must be single color with 640x400 pixels!\n\n");
    return 1;
  }

  /* copy all fields */
  for(y=0;y<400;y++)
  {
    for(x=0;x<80;x++)
    {
      charsetbuf[y*80+x] = picbuf[62+((399-y)*80)+x]^0xFF;
    }
  }

  /* write binary grafix file */
  fout = fopen(argv[2],"wb");
  if (!fout)
  {
    printf("failed to open destination (grafix) file!\n\n");
    return 1;
  }
  if (fwrite(charsetbuf,1,32000,fout)!=32000)
  {
    printf("failed to write grafix file!\n\n");
    fclose(fout);
    return 1;
  }
  fclose(fout);
  printf("binary grafix file successfully created!\n\n");
  return 0;
}
