#include <stdio.h>
#include <conio.h>

unsigned char picbuf[4158];


int main(int argc, char* argv[])
{
  FILE *fin, *fout;
  int j,o,no,ino,o2,no2,ino2;
  unsigned char cbuf[8];

  printf("\nBitmap-Charset: This program converts a 80x25 charset\n");
  printf("to a charset for a 80x50 screen.\n\n");
  if (argc != 2)
  {
    printf("Parameters:   bmpsmall  bitmapfile\n\n");
    return 0;
  }

  /* load bitmap file */
  fin = fopen(argv[1],"rb");
  if (!fin)
  {
    printf("failed to open bitmap file!\n\n");
    return 1;
  }
  if (fread(picbuf,1,4158,fin)!=4158)
  {
    printf("failed to read bitmap file!\n\n");
    fclose(fin);
    return 1;
  }
  fclose(fin);
  if ((picbuf[0]!=0x42)||(picbuf[1]!=0x4d)||(picbuf[2]!=0x3e)||
      (picbuf[17]!=0)||(picbuf[18]!=0x80)||
      (picbuf[22]!=0)||(picbuf[23]!=0x01))
  {
    printf("error: bitmap must be single color with 128x128 pixels!\n\n");
    return 1;
  }

  /* copy all characters and reduce the size */
  for(no=0;no<256;no++)
  {
    ino = 255-no;
    o = 62 + (ino/16)*256+(no%16);

    for (j=0;j<8;j++)
    {
      cbuf[j] = ~(~picbuf[o+(14-j*2)*16] | ~picbuf[o+(15-j*2)*16]);
    }
    for (j=0;j<8;j++)
    {
      picbuf[o+( 7-j)*16] = cbuf[j];
      picbuf[o+(15-j)*16] = cbuf[j];
    }
  }

  /* write bitmap file */
  fout = fopen(argv[1],"wb");
  if (!fout)
  {
    printf("failed to open destination file!\n\n");
    return 1;
  }
  if (fwrite(picbuf,1,4158,fout)!=4158)
  {
    printf("failed to write bitmap file!\n\n");
    fclose(fout);
    return 1;
  }
  fclose(fout);
  printf("done.\n\n");
  return 0;
}
