#include <stdio.h>
#include <conio.h>

unsigned char picbuf[4158];
unsigned char charsetbuf[4096];


int main(int argc, char* argv[])
{
  FILE *fin, *fout;
  int j,o,no,ino,rd;
  printf("\nCharset to Bitmap converter V1.0\n\n");
  if (argc != 3)
  {
    printf("Parameters:   char2bmp  charsetfile  bitmapfile\n\n");
    return 0;
  }

  /* load charset file */
  fin = fopen(argv[1],"rb");
  if (!fin)
  {
    printf("failed to open charset file!\n\n");
    return 1;
  }
  rd = fread(charsetbuf,1,4096,fin);
  if ((rd!=2048) && (rd!=4096))
  {
    printf("failed to read charset file!\n\n");
    fclose(fin);
    return 1;
  }
  fclose(fin);

  /* build file header */
  for(j=0;j<62;j++) picbuf[j]=0;
  picbuf[0] = 0x42;  picbuf[1] = 0x4d;  picbuf[2] = 0x3e;
  picbuf[3] = 0x10;  picbuf[10] = 0x3e; picbuf[14] = 0x28;
  picbuf[18] = 0x80; picbuf[23] = 0x01; picbuf[26] = 0x01;
  picbuf[28] = 0x01; picbuf[35] = 0x10; picbuf[38] = 0xCE;
  picbuf[39] = 0x0E; picbuf[42] = 0xC4; picbuf[43] = 0x0E;
  picbuf[58] = 0xFF; picbuf[59] = 0xFF; picbuf[60] = 0xFF;

  /* copy all characters */
  for(no=0;no<256;no++)
  {
    ino = 255-no;
    o = 62 + (ino/16)*256+(no%16);
    if (rd==2048)
    {
      for (j=0;j<16;j+=2)
      {
        picbuf[o+(15-j)*16] = charsetbuf[(no<<3)+(j/2)]^0xFF;
        picbuf[o+(15-j-1)*16] = charsetbuf[(no<<3)+(j/2)]^0xFF;
      }
    }
    else
    {
      for (j=0;j<16;j++)
      {
        picbuf[o+(15-j)*16] = charsetbuf[(no<<4)+j]^0xFF;
      }
    }
  }

  /* write bitmap file */
  fout = fopen(argv[2],"wb");
  if (!fout)
  {
    printf("failed to open destination (bitmap) file!\n\n");
    return 1;
  }
  if (fwrite(picbuf,1,4158,fout)!=4158)
  {
    printf("failed to write bitmap file!\n\n");
    fclose(fout);
    return 1;
  }
  fclose(fout);
  printf("Bitmap file successfully created!\n\n");
  return 0;
}
